﻿
namespace BeeDevelopment.PlayJoy {

	/// <summary>
	/// Represents an analogue stick position.
	/// </summary>
	public struct JoystickPosition {
		private float x;
		/// <summary>
		/// Gets or sets the X component of the joystick position.
		/// </summary>
		public float X { get { return this.x; } set { this.x = value; } }
		private float y;
		/// <summary>
		/// Gets or sets the Y component of the joystick position.
		/// </summary>
		public float Y { get { return this.y; } set { this.y = value; } }
		
		/// <summary>
		/// Creates an instance of <see cref="JoystickPosition"/>.
		/// </summary>
		/// <param name="x">The X component of the joystick position.</param>
		/// <param name="y">The Y component of the joystick position.</param>
		public JoystickPosition(float x, float y) {
			this.x = x;
			this.y = y;
		}

		/// <summary>
		/// Creates an instance of <see cref="JoystickPosition"/>.
		/// </summary>
		/// <param name="x">The X component of the joystick position.</param>
		/// <param name="y">The Y component of the joystick position.</param>
		internal JoystickPosition(byte x, byte y)
			: this((x - 127.5f) / 128f, (y - 127.5f) / 128f) {
		}
	}
}
